
module TypeChecker.Rewriting where

import Syntax.Name
import Syntax.Values
import Utils.Map

data HeadSymbol	= HDef Name | HVar Int
data RulePat
	= RDef Name [Either RulePat ProjectionValue]
	| RVar Name Int [Either RulePat ProjectionValue]
	| Any
data RewriteRule  = RewriteRule RulePat Value
type RewriteRules = Map HeadSymbol [RewriteRule]

addRewriteRule :: RewriteRule -> RewriteRules -> RewriteRules

