
module TypeChecker.Substitution where

import Utils.Map
import Syntax.Internal

type Substitution = Map Name Value

identitySubst :: Substitution
identitySubst = emptyMap

extendSubst :: Name -> Value -> Substitution -> Substitution
extendSubst = updateMap

lookupSubst :: Name -> Type -> Substitution -> Value
lookupSubst x t = lookupMap' (VId x t) x

plusSubst :: Substitution -> Substitution -> Substitution
plusSubst = plusMap

