-- Bug: When translating a value to a term, hidden arguments aren't taken into account.
-- Status: Fixed

A : Set
T : A -> Set
t : (a:A) -> T a

sig Foo : Set where
  x (a:A) : T a

foo : Foo
foo =
  struct
    x {a} = t a

data H : Foo -> Set where
  h : H foo

bar : (f:Foo) -> H f -> A
bar _ h = assert-plugin(silent)

