
-- # import Property

data Nat : Set where
  zero : Nat
  suc  : Nat -> Nat

data Bool : Set where
  true, false : Bool

Holds : Bool -> Prop
Holds true  = True
Holds false = False

isZero : Nat -> Prop
isZero 0       = True
isZero (suc n) = False

(<=) : Nat -> Nat -> Bool
0     <= _     = true
suc n <= 0     = false
suc n <= suc m = n <= m

sig Less : Type where
  x, y : Nat
  less : Holds (x <= y)

sig Foo : Type where
  l : Less
  x : Prop
  y : Less

foo : Less
bar : Foo

a = foo.x
b = foo.y
c = foo.less
d = bar.l.less
d' = bar.l
e = bar.x
f = bar.y

